/* Microsoft SQL Server - Scripting			*/
/* Database: eshop					*/
/* Creation Date 31/10/97 22:22:09 			*/

/****** Object:  Table dbo.Baskets    Script Date: 31/10/97 22:22:10 ******/
if exists (select * from sysobjects where id = object_id('dbo.Baskets') and sysstat & 0xf = 3)
	drop table dbo.Baskets
GO

/****** Object:  Table dbo.Catalog    Script Date: 31/10/97 22:22:10 ******/
if exists (select * from sysobjects where id = object_id('dbo.Catalog') and sysstat & 0xf = 3)
	drop table dbo.Catalog
GO

/****** Object:  Table dbo.Customers    Script Date: 31/10/97 22:22:10 ******/
if exists (select * from sysobjects where id = object_id('dbo.Customers') and sysstat & 0xf = 3)
	drop table dbo.Customers
GO

/****** Object:  Table dbo.Baskets    Script Date: 31/10/97 22:22:11 ******/
CREATE TABLE dbo.Baskets (
	BasketId int IDENTITY (1, 1) NOT NULL ,
	CustomerId int NOT NULL ,
	CatalogId int NOT NULL ,
	NumItems int NOT NULL 
)
GO

/****** Object:  Table dbo.Catalog    Script Date: 31/10/97 22:22:16 ******/
CREATE TABLE dbo.Catalog (
	CatalogId int IDENTITY (1, 1) NOT NULL ,
	Code char (10) NOT NULL ,
	Type char (10) NOT NULL ,
	Name char (50) NOT NULL ,
	Description char (250) NOT NULL ,
	ImageURL char (25) NOT NULL ,
	Price char (10) NOT NULL ,
	PromotionCode char (1) NOT NULL ,
	PromotionEndDate datetime NOT NULL ,
	PublicationDate datetime NOT NULL 
)
GO

/****** Object:  Table dbo.Customers    Script Date: 31/10/97 22:22:16 ******/
CREATE TABLE dbo.Customers (
	CustomerId int IDENTITY (1, 1) NOT NULL ,
	Email char (50) NOT NULL ,
	Firstname char (25) NOT NULL ,
	Surname char (25) NOT NULL ,
	Address char (40) NOT NULL ,
	City char (20) NOT NULL ,
	State char (20) NOT NULL ,
	ZipCode char (10) NOT NULL ,
	Country char (20) NOT NULL ,
	Phone char (20) NOT NULL ,
	Passcode char (20) NOT NULL ,
	UseCookie char (1) NOT NULL ,
	Interests char (10) NOT NULL 
)
GO

